function metricCharts(opts){

    // Initialize opts etc, clear out ajax.
    opts = metricStarter(opts);

    // Store reference for cancellation or deferred response
    hl.chart.metricsAjax = $.ajax({ // ajax call starts
          url: "json/headlineData.json", // JQuery loads serverside.php
          data: opts,
          cache: false,
          dataType: 'json', // Choosing a JSON datatype
          success: function(response){ // Variable data contains the data we get from serverside

            prettifyMetrics(response.data.chartValues);

            metricEnder();
          }
    });


}

function mainChart(opts){

    if (typeof opts == "undefined"){
      opts = {};
    }
    opts = $.extend(true, hl.chart.opts, opts);

    // This is for demo purposes - it should ultimately
    // be the same path with diff data params
    var jsonPath = "json/mainChartCtrData.json";
    if (opts.type == "stackedAreaChart"){
      jsonPath = "json/mainChartClickData.json";
    }


    // Store reference for cancellation or deferred response
    hl.chart.mainChartAjax = $.ajax({ // ajax call starts
          url: jsonPath, // JQuery loads serverside.php
          data: opts,
          cache: false,
          dataType: 'json', // Choosing a JSON datatype
          success: function(response) // Variable data contains the data we get from serverside
          {
            if (opts.type == "stackedAreaChart"){
              doStackedAreaChart(response.data.chartValues, opts);
            }
            else if (opts.type == "barChartWithTrend"){
              doBarChartWithTrend(response.data.chartValues, opts);
            }

            $("#primaryChart").prevAll().remove();
            $("#primaryChartLoader").addClass("hidelt");

          }
      });
}


function doStackedAreaChart(data, opts){
    console.log(data);

    // High Charts values for the chart
    /*
    var hc = {
        chart: {
            type: 'area'
        },
        title: {
            text: 'Historic and Estimated Worldwide Population Growth by Region'
        },
        subtitle: {
            text: 'Source: Wikipedia.org'
        },
        xAxis: {
            categories: [],
            tickmarkPlacement: 'on',
            title: {
                enabled: false
            }
        },
        yAxis: {
            title: {
                text: 'Clicks'
            },
            labels: {
                formatter: function() {
                    return this.value;
                }
            }
        },
        tooltip: {
            crosshairs: true,
            shared: true
        },
        plotOptions: {
            area: {
                stacking: 'normal',
                lineWidth: 0,
                marker: {
                    enabled: false,
                    states: {
                        hover: {
                            enabled: true
                        }
                    }
                }
            }
        },
        series: []
    };
    */
    $.each(data, function(catInd,catVal){

        // Create object we'll later push into hc.series
        var seriesItem = {
            name: catVal.key,
            data: []
        };

        $.each(catVal.values, function(i,v){

            // HC wants a separate X axis chart, which we only need to
            // generate once (thus index == 0)
            if (catInd == 0){

                // First format the date
                var prettyDate = moment(v[0]).format("MM" + "/" + "DD");
                hc.xAxis.categories.push(prettyDate); // Push date to HC X Axis
            }

            // Create array of data
            seriesItem.data.push(v[1]);

        })

        // Push the newly created series object into hc.series
        hc.series.push(seriesItem);
    })

    $('#ie8Chart').highcharts(hc);
}

function doBarChartWithTrend(data, opts){
    console.log(data);

    // High Charts values for the chart
    var hc = {
            chart: {
            },
            title: {
                text: 'Combination chart'
            },
            xAxis: {
                categories: []
            },
            tooltip: {
                crosshairs: true,
                formatter: function() {
                    var s;
                    if (this.point.name) { // the pie chart
                        s = ''+
                            this.point.name +': '+ this.y +' fruits';
                    } else {
                        s = ''+
                            this.x  +': '+ this.y;
                    }
                    return s;
                }
            },
            plotOptions: {
                spline: {
                    marker: {
                        enabled: false,
                        states: {
                            hover: {
                                enabled: false
                            }
                        }
                    }
                }
            },
            series: []
        }
    $.each(data, function(catInd,catVal){

        // Create object we'll later push into hc.series
        var seriesItem = {
            name: catVal.key,
            data: []
        };

        // Make the first response a bar and the second a line chart
        if (catInd == 0){
            seriesItem.type = "column";
        }
        else {
            seriesItem.type = "spline";
        }

        $.each(catVal.values, function(i,v){

            // HC wants a separate X axis chart, which we only need to
            // generate once (thus index == 0)
            if (catInd == 0){

                // First format the date
                var prettyDate = moment(v[0]).format("MM" + "/" + "DD");
                hc.xAxis.categories.push(prettyDate); // Push date to HC X Axis
            }

            // Create array of data
            seriesItem.data.push(v[1]);

        })

        // Push the newly created series object into hc.series
        hc.series.push(seriesItem);
    })

    $('#ie8Chart').highcharts(hc);
}
